var sServerURL="https://dsservices.aizo.com";

try {
	if (Property.getNode('/config/webservice-api/base-url')!=null) {
		sServerURL=Property.getNode('/config/webservice-api/base-url').getValue();
	}
} catch (e) {}

//lInfo.logln("sServerURL=" + sServerURL);


var cloudService = {
    makePostCall:function(sFunction,func,data) {
    	
        lInfo.logln("http post reuqest " + sFunction);
        lInfo.logln("body " + data);
        try {
        
        	var handle = new WebserviceConnection();
        	handle.request(sFunction, 'POST', {'Content-Type':'application/json','NotificationTextIsUrlEncodedUtf7':'true'},
        			data
        				, function(code, retdata) {
        				if (code === 200) {
                            lInfo.logln( ': OK [' + code + ']');
                        } else {
                            lWarn.logln(': FAILED! Server replied: "' + code + '"');
                        }
                  lInfo.logln(retdata);
                  func(JSON.parse(retdata));
        			});
        } catch (e) {
            lWarn.logln("Exception during http post reuqest " + sFunction+": ");
            for (var i in e) {
                lWarn.logln(i + ': ' + e[i]);
            }
        }
    },
    makeGetCall:function(sFunction,func,options) {
        var extraheaders = [];
        lInfo.logln("sServerURL=" + sServerURL);
        lInfo.logln("http get reuqest " + sFunction);
        try {
            if (options==null)
                options= { 'debug' : 0};
            else
                options.debug=0;
            
            var handle = new WebserviceConnection();
            handle.simplerequest(sFunction, 'GET', function(code, data) {
                if (code === 200) {
                    lInfo.logln( ': OK [' + code + ']');
                } else {
                    lInfo.logln(': FAILED! Server replied: "' + code + '"');
                }
                lInfo.logln(data);
                func(JSON.parse(data));
            });
        } catch (e) {
            lWarn.logln("Error during upload: ");
            for (var i in e) {
                lWarn.logln(i + ': ' + e[i]);
            }
        }
    },
    /*
    fakeCreateFile:function(func) {
       var data = '{"Response": {"TextToSpeechVoiceFileGuid": "46b6b434-fb61-2ccb-2e1d-330bd5f18712","VoiceFile": "QEBA"},"ReturnCode": 0,"ReturnMessage": "OK"}';
       var dataExeced = '{"Response": {"TextToSpeechVoiceFileGuid": "46b6b434-fb61-2ccb-2e1d-330bd5f18712","VoiceFile": "QEBA"},"ReturnCode": 79,"ReturnMessage": "Response Message "}';
       var dataOther = '{"Response": {"TextToSpeechVoiceFileGuid": "6464afc1-8a2e-4192-a270-42e69559b31c","VoiceFile": "QEBA"},"ReturnCode": 0,"ReturnMessage": "OK"}';
       func(JSON.parse(dataExeced));
    },
    fakeDeleteFile:function(func) {
       var data = '{"Response": {},"ReturnCode": 0,"ReturnMessage": "OK"}';
       lWarn.logln("Inside fake delete");
       func(JSON.parse(data));
    },*/
    getOSPToken:function() {
      if (Property.getNode('/scripts/remote-connectivity/OSPToken') != null)
		    return Property.getNode('/scripts/remote-connectivity/OSPToken').getValue();
      return null;
    },
    getCloudEmail:function() {
      if (Property.getNode('/scripts/remote-connectivity/username'))
		    return Property.getNode('/scripts/remote-connectivity/username').getValue();
      return null;
    },
    getMyDSID:function(){
		  return Property.getProperty('/system/dSID');			
	  },
    getLanguage:function(){
      return Property.getProperty('/system/language/locale').replace('_','-');      
      //return Property.getProperty('/system/language/locale');      
    },
    startService:function(func) {
      var sToken = this.getOSPToken();
      if (sToken != null) {
        var url='/public/service/v1_0/MediaLibrary/StartMediaService?dsid='+this.getMyDSID()+'&token='+sToken;
        this.makePostCall(url,func,"{}");
      }
    },
    createTextSound:function(sGUIDFolder, sLang, sVoiceName, sText,func) {
      var url='/public/service/v1_0/MediaLibrary/CreateVoiceFile?serviceName=MediaService&dsid='+this.getMyDSID()+'&token='+this.getOSPToken()+"&serviceToken=2a24a321af65aef114a9&languageCode="+sLang+"&text="+encodeURI(sText)+"&mediaLibraryPath="+sGUIDFolder+"&voiceName="+sVoiceName;
      this.makePostCall(url,func,"{}");
      //this.fakeCreateFile(func);
    },
    deleteTextSound:function(sGUID,func) {
      var url='/public/service/v1_0/MediaLibrary/DeleteVoiceFile?dsid='+this.getMyDSID()+'&token='+this.getOSPToken()+'&textToSpeechVoiceFileGuid='+sGUID+'';//&deleteAll=False
      this.makeGetCall(url,func,"{}");
      //this.fakeDeleteFile(func);
    },
    fetchText2SpeechConf:function(func) {
      var url='/public/service/v1_0/MediaLibrary/GetTextToSpeechConfiguration?serviceName=MediaService&dsid='+this.getMyDSID()+'&token='+this.getOSPToken();
      this.makeGetCall(url,func);
    },
    fetchMediaLibrary:function(func) {
      var sToken = this.getOSPToken();
      if (sToken != null) {
        var url='/public/service/v1_0/MediaLibrary/GetMediaLibrary?dsid='+this.getMyDSID()+'&token='+sToken+'&includeMediaFileNames=true&languageCode='+this.getLanguage();
        this.makeGetCall(url,func);
      }
    },
    fetchMediaFile:function(sFileID, func) {
      lInfo.logln("sFileID="+sFileID);
      var url='/public/service/v1_0/MediaLibrary/GetMediaFile?dsid='+this.getMyDSID()+'&token='+this.getOSPToken()+'&mediaFileGuid='+sFileID+'&languageCode='+this.getLanguage();
    	this.makeGetCall(url,func);
    }
};